// bbq - Copyright (C) 2005, Axel Mosig, University of Leipzig. See
// main.cpp for details.

#include "bbq_postscript.h"

namespace bbq {
	
void print_ps_header(std::ostream& o)
{
	o<<"%!\n";
	o<<"%% bbq output\n";

	o<<"/inch {72 mul} def      % Convert inches->points (1/72 inch)\n";
	o<<"/sh_scale {1 mul} def   % scale for interval shapes\n";
	o<<"/sh_fill {col2} def % gray level for filling shapes\n";
	o<<"/sh_border {0} def % gray level for shape borders\n";
	o<<"/sh_line {1} def % gray level for filling shapes\n";

	o<<"/srgb {setrgbcolor} bind def\n";
	o<<"/col0 {0.000 0.000 0.000 srgb} bind def\n";
	o<<"/col1 {0.000 0.000 1.000 srgb} bind def\n";
	o<<"/col2 {0.000 1.000 0.000 srgb} bind def\n";
	o<<"/col3 {0.000 1.000 1.000 srgb} bind def\n";
	o<<"/col4 {1.000 0.000 0.000 srgb} bind def\n";
	o<<"/col5 {1.000 0.000 1.000 srgb} bind def\n";
	o<<"/col6 {1.000 1.000 0.000 srgb} bind def\n";
	o<<"/col7 {1.000 1.000 1.000 srgb} bind def\n";
	o<<"/col8 {0.000 0.690 0.690 srgb} bind def\n";
	o<<"/col9 {0.630 0.250 0.000 srgb} bind def\n";
	o<<"/col10 {1.000 0.630 0.630 srgb} bind def\n";
	o<<"/col11 {0.500 0.500 0.500 srgb} bind def\n";
	o<<"/col12 {0.000 0.560 0.000 srgb} bind def\n";
	o<<"/col13 {0.000 0.690 0.000 srgb} bind def\n";
	o<<"/col14 {0.000 0.820 0.000 srgb} bind def\n";
	o<<"/col15 {0.000 0.560 0.560 srgb} bind def\n";
	o<<"/col16 {0.000 0.000 0.560 srgb} bind def\n";
	o<<"/col17 {0.000 0.820 0.820 srgb} bind def\n";
	o<<"/col18 {0.560 0.000 0.000 srgb} bind def\n";
	o<<"/col19 {0.690 0.000 0.000 srgb} bind def\n";
	o<<"/col20 {0.820 0.000 0.000 srgb} bind def\n";
	o<<"/col21 {0.560 0.000 0.560 srgb} bind def\n";
	o<<"/col22 {0.690 0.000 0.690 srgb} bind def\n";
	o<<"/col23 {0.820 0.000 0.820 srgb} bind def\n";
	o<<"/col24 {0.500 0.190 0.000 srgb} bind def\n";
	o<<"/col25 {0.000 0.000 0.690 srgb} bind def\n";
	o<<"/col26 {0.750 0.380 0.000 srgb} bind def\n";
	o<<"/col27 {1.000 0.500 0.500 srgb} bind def\n";
	o<<"/col28 {0.000 0.000 0.820 srgb} bind def \n";
	o<<"/col29 {1.000 0.750 0.750 srgb} bind def\n";
	o<<"/col30 {1.000 0.880 0.880 srgb} bind def\n";
	o<<"/col31 {1.000 0.840 0.000 srgb} bind def\n";
	o<<"\n";
	o<<"/sh0 {shape_sq} bind def\n";
	o<<"/sh1 {shape_dmnd} bind def\n";
	o<<"/sh2 {shape_crc} bind def\n";
	o<<"/sh3 {shape_st} bind def\n";
	o<<"/sh4 {shape_tr_n} bind def\n";
	o<<"/sh5 {shape_tr_e} bind def\n";
	o<<"/sh6 {shape_tr_s} bind def\n";
	o<<"/sh7 {shape_tr_w} bind def\n";
	o<<"/sh8 {shape_moon_n} bind def\n";
	o<<"/sh9 {shape_moon_e} bind def\n";
	o<<"/sh10 {shape_moon_s} bind def\n";
	o<<"/sh11 {shape_moon_w} bind def\n";
	o<<"\n";
	o<<"% square shape\n";
	o<<"/shape_sq {\n";
	o<<"  gsave\n";
	o<<"  col1 \n";
	o<<"  sh_fill\n";
	o<<"  sh_line setlinewidth\n";
	o<<"  newpath\n";
	o<<"  moveto   \n";                             
	o<<"  -5 sh_scale -5 sh_scale rmoveto \n";
	o<<"  0 sh_scale 10 sh_scale rlineto    \n";    
	o<<"  10 sh_scale 0 sh_scale rlineto      \n";  
	o<<"  0 sh_scale -10 sh_scale rlineto\n";
	o<<"  -10 sh_scale 0 sh_scale rlineto\n";
	o<<"  currentpoint\n";
	o<<"  closepath\n";
	o<<"  fill\n";
	o<<"  newpath\n";
	o<<"  moveto\n";
	o<<"  sh_border setgray\n";
	o<<"  0 sh_scale 10 sh_scale rlineto        \n";
	o<<"  10 sh_scale 0 sh_scale rlineto        \n";
	o<<"  0 sh_scale -10 sh_scale rlineto       \n";
	o<<"  closepath\n";
	o<<"  stroke\n";
	o<<"  grestore\n";
	o<<"} bind def\n";
	o<<"% star shape\n";
	o<<"/shape_st {\n";
	o<<"  gsave\n";
	o<<"  sh_fill\n";
	o<<"  sh_line setlinewidth\n";
	o<<"  newpath\n";
	o<<"  moveto   \n";                             
	o<<"  2.5 sh_scale 0 sh_scale rmoveto \n";
	o<<"  2.5 sh_scale 5 sh_scale rlineto   \n";     
	o<<"  -5 sh_scale -2.5 sh_scale rlineto   \n";     
	o<<"  -5 sh_scale 2.5 sh_scale rlineto      \n";  
	o<<"  2.5 sh_scale -5 sh_scale rlineto        \n";
	o<<"  -2.5 sh_scale -5 sh_scale rlineto        \n";
	o<<"  5 sh_scale 2.5 sh_scale rlineto        \n";
	o<<"  5 sh_scale -2.5 sh_scale rlineto        \n";
	o<<"  -2.5 sh_scale 5 sh_scale rlineto\n";
	o<<"  -2.5 sh_scale 0 rmoveto\n";
	o<<"  currentpoint\n";
	o<<"  closepath\n";
	o<<"  fill\n";
	o<<"  newpath\n";
	o<<"  moveto\n";
	o<<"  sh_border setgray\n";
	o<<"  2.5 sh_scale 0 sh_scale rmoveto \n";
	o<<"  2.5 sh_scale 5 sh_scale rlineto   \n";     
	o<<"  -5 sh_scale -2.5 sh_scale rlineto   \n";     
	o<<"  -5 sh_scale 2.5 sh_scale rlineto      \n";  
	o<<"  2.5 sh_scale -5 sh_scale rlineto        \n";
	o<<"  -2.5 sh_scale -5 sh_scale rlineto        \n";
	o<<"  5 sh_scale 2.5 sh_scale rlineto        \n";
	o<<"  5 sh_scale -2.5 sh_scale rlineto        \n";
	o<<"  -2.5 sh_scale 5 sh_scale rlineto\n";
	o<<"  closepath\n";
	o<<"  stroke\n";
	o<<"  grestore\n";
	o<<"} bind def\n";
	o<<"\n";
	o<<"% diamond shape\n";
	o<<"/shape_dmnd {\n";
	o<<"  gsave	\n";
	o<<"  sh_fill\n";
	o<<"  sh_line setlinewidth                  	\n";
	o<<"  newpath\n";
	o<<"  moveto   \n";                             
	o<<"  -7.07 sh_scale 0 sh_scale rmoveto \n";
	o<<"  7.07 sh_scale 7.07 sh_scale rlineto\n";
	o<<"  7.07 sh_scale -7.07 sh_scale rlineto\n";
	o<<"  -7.07 sh_scale -7.07 sh_scale rlineto\n";
	o<<"  -7.07 sh_scale 7.07 sh_scale rlineto\n";
	o<<"  currentpoint\n";
	o<<"  closepath\n";
	o<<"  fill\n";
	o<<"  sh_border setgray\n";
	o<<"  newpath\n";
	o<<"  moveto                                \n";
	o<<"  7.07 sh_scale 7.07 sh_scale rlineto\n";
	o<<"  7.07 sh_scale -7.07 sh_scale rlineto\n";
	o<<"  -7.07 sh_scale -7.07 sh_scale rlineto\n";
	o<<"  -7.07 sh_scale 7.07 sh_scale rlineto\n";
	o<<"  currentpoint\n";
	o<<"  closepath\n";
	o<<"  stroke\n";
	o<<"  grestore\n";
	o<<"} bind def\n";
	o<<"\n";
	o<<"% circle shape\n";
	o<<"/shape_crc {\n";
	o<<"  gsave	\n";
	o<<"  sh_fill\n";
	o<<"  sh_line setlinewidth                  	\n";
	o<<"  newpath\n";
	o<<"  7.07 sh_scale 0 360 arc\n";
	o<<"  -7.07 sh_scale 0 rmoveto\n";
	o<<"  currentpoint\n";
	o<<"  closepath\n";
	o<<"  fill\n";
	o<<"  sh_border setgray\n";
	o<<"  newpath\n";
	o<<"  7.07 sh_scale 0 360 arc\n";
	o<<"  currentpoint\n";
	o<<"  closepath\n";
	o<<"  stroke\n";
	o<<"  grestore\n";
	o<<"} bind def\n";
	o<<"\n";
	o<<"% moon shape\n";
	o<<"/shape_moon_n {\n";
	o<<"  gsave	\n";
	o<<"  sh_fill\n";
	o<<"  sh_line setlinewidth                  	\n";
	o<<"  newpath\n";
	o<<"  7.07 sh_scale 0 180 arc\n";
	o<<"  7.07 sh_scale 0 rmoveto\n";
	o<<"  currentpoint\n";
	o<<"  closepath\n";
	o<<"  fill\n";
	o<<"  sh_border setgray\n";
	o<<"  newpath\n";
	o<<"  7.07 sh_scale 0 180 arc\n";
	o<<"  currentpoint\n";
	o<<"  closepath\n";
	o<<"  stroke\n";
	o<<"  grestore\n";
	o<<"} bind def\n";
	o<<"\n";
	o<<"% moon shape\n";
	o<<"/shape_moon_e {\n";
	o<<"  gsave	\n";
	o<<"  sh_fill\n";
	o<<"  sh_line setlinewidth                  	\n";
	o<<"  newpath\n";
	o<<"  7.07 sh_scale 270 90 arc\n";
	o<<"  0 -7.07 sh_scale rmoveto\n";
	o<<"  currentpoint\n";
	o<<"  closepath\n";
	o<<"  fill\n";
	o<<"  sh_border setgray\n";
	o<<"  newpath\n";
	o<<"  7.07 sh_scale 270 90 arc\n";
	o<<"  currentpoint\n";
	o<<"  closepath\n";
	o<<"  stroke\n";
	o<<"  grestore\n";
	o<<"} bind def\n";
	o<<"\n";
	o<<"% moon shape\n";
	o<<"/shape_moon_s {\n";
	o<<"  gsave	\n";
	o<<"  sh_fill\n";
	o<<"  sh_line setlinewidth                  	\n";
	o<<"  newpath\n";
	o<<"  7.07 sh_scale 180 360 arc\n";
	o<<"  -7.07 sh_scale 0 rmoveto\n";
	o<<"  currentpoint\n";
	o<<"  closepath\n";
	o<<"  fill\n";
	o<<"  sh_border setgray\n";
	o<<"  newpath\n";
	o<<"  7.07 sh_scale 180 360 arc\n";
	o<<"  currentpoint\n";
	o<<"  closepath\n";
	o<<"  stroke\n";
	o<<"  grestore\n";
	o<<"} bind def\n";
	o<<"\n";
	o<<"% moon shape\n";
	o<<"/shape_moon_w {\n";
	o<<"  gsave	\n";
	o<<"  sh_fill\n";
	o<<"  sh_line setlinewidth                  	\n";
	o<<"  newpath\n";
	o<<"  7.07 sh_scale 90 270 arc\n";
	o<<"  0 7.07 sh_scale rmoveto\n";
	o<<"  currentpoint\n";
	o<<"  closepath\n";
	o<<"  fill\n";
	o<<"  sh_border setgray\n";
	o<<"  newpath\n";
	o<<"  7.07 sh_scale 90 270 arc\n";
	o<<"  currentpoint\n";
	o<<"  closepath\n";
	o<<"  stroke\n";
	o<<"  grestore\n";
	o<<"} bind def\n";
	o<<"\n";
	o<<"% triangle pointing south shape\n";
	o<<"/shape_tr_s {\n";
	o<<"  gsave	\n";
	o<<"  sh_fill\n";
	o<<"  sh_line setlinewidth                  	\n";
	o<<"  newpath\n";
	o<<"  moveto   \n";                             
	o<<"  0 sh_scale -5 sh_scale rmoveto \n";
	o<<"  5 sh_scale 10 sh_scale rlineto\n";
	o<<"  -10 sh_scale 0 sh_scale rlineto\n";
	o<<"  5 sh_scale -10 sh_scale rlineto\n";
	o<<"  currentpoint\n";
	o<<"  closepath\n";
	o<<"  fill\n";
	o<<"  sh_border setgray\n";
	o<<"  newpath\n";
	o<<"  moveto   \n";                             
	o<<"  5 sh_scale 10 sh_scale rlineto\n";
	o<<"  -10 sh_scale 0 sh_scale rlineto\n";
	o<<"  5 sh_scale -10 sh_scale rlineto\n";
	o<<"  currentpoint\n";
	o<<"  closepath\n";
	o<<"  stroke\n";
	o<<"  grestore\n";
	o<<"} bind def\n";
	o<<"\n";
	o<<"% triangle pointing south shape\n";
	o<<"/shape_tr_e {\n";
	o<<"  gsave	\n";
	o<<"  sh_fill\n";
	o<<"  sh_line setlinewidth                  	\n";
	o<<"  newpath\n";
	o<<"  moveto   \n";                             
	o<<"  5 sh_scale 0 sh_scale rmoveto \n";
	o<<"  -10 sh_scale 5 sh_scale rlineto\n";
	o<<"  0 sh_scale -10 sh_scale rlineto\n";
	o<<"  10 sh_scale 5 sh_scale rlineto\n";
	o<<"  currentpoint\n";
	o<<"  closepath\n";
	o<<"  fill\n";
	o<<"  sh_border setgray\n";
	o<<"  newpath\n";
	o<<"  moveto   \n";                             
	o<<"  -10 sh_scale 5 sh_scale rlineto\n";
	o<<"  0 sh_scale -10 sh_scale rlineto\n";
	o<<"  10 sh_scale 5 sh_scale rlineto\n";
	o<<"  currentpoint\n";
	o<<"  closepath\n";
	o<<"  stroke\n";
	o<<"  grestore\n";
	o<<"} bind def\n";
	o<<"\n";
	o<<"/shape_tr_n {\n";
	o<<"  gsave	\n";
	o<<"  sh_fill\n";
	o<<"  sh_line setlinewidth                  	\n";
	o<<"  newpath\n";
	o<<"  moveto   \n";                             
	o<<"  0 sh_scale 5 sh_scale rmoveto \n";
	o<<"  -5 sh_scale -10 sh_scale rlineto\n";
	o<<"  10 sh_scale 0 sh_scale rlineto\n";
	o<<"  -5 sh_scale 10 sh_scale rlineto\n";
	o<<"  currentpoint\n";
	o<<"  closepath\n";
	o<<"  fill\n";
	o<<"  sh_border setgray\n";
	o<<"  newpath\n";
	o<<"  moveto   \n";                             
	o<<"  -5 sh_scale -10 sh_scale rlineto\n";
	o<<"  10 sh_scale 0 sh_scale rlineto\n";
	o<<"  -5 sh_scale 10 sh_scale rlineto\n";
	o<<"  currentpoint\n";
	o<<"  closepath\n";
	o<<"  stroke\n";
	o<<"  grestore\n";
	o<<"} bind def\n";
	o<<"\n";
	o<<"% triangle pointing south shape\n";
	o<<"/shape_tr_w {\n";
	o<<"  gsave	\n";
	o<<"  sh_fill\n";
	o<<"  sh_line setlinewidth                  	\n";
	o<<"  newpath\n";
	o<<"  moveto   \n";                             
	o<<"  -5 sh_scale 0 sh_scale rmoveto \n";
	o<<"  10 sh_scale -5 sh_scale rlineto\n";
	o<<"  0 sh_scale 10 sh_scale rlineto\n";
	o<<"  -10 sh_scale -5 sh_scale rlineto\n";
	o<<"  currentpoint\n";
	o<<"  closepath\n";
	o<<"  fill\n";
	o<<"  sh_border setgray\n";
	o<<"  newpath\n";
	o<<"  moveto   \n";                             
	o<<"  10 sh_scale -5 sh_scale rlineto\n";
	o<<"  0 sh_scale 10 sh_scale rlineto\n";
	o<<"  -10 sh_scale -5 sh_scale rlineto\n";
	o<<"  currentpoint\n";
	o<<"  closepath\n";
	o<<"  stroke\n";
	o<<"  grestore\n";
	o<<"} bind def\n";
	o<<"\n";
	o<<"/Courier findfont\n";
	o<<"12 scalefont     \n";
	o<<"setfont          \n";
	o<<"\n";
}

void print_ps_footer(std::ostream& o)
{
	o<<"showpage\n";
}

int get_col(int j)
{
	return (j/12 + j%12) % 12;
}

int get_sh(int j)
{
	return j%12;	
}

float get_pos(int x, int L)
{
	return 150. + 400.*(((float)x)/(float)L);
}

void print_cluster(int ypos, std::string name, int beg, int end, int L, ps_match_list ml, std::ostream& o)
{
	o<<"/ypos {"<<ypos<<"} def\n";
	o<<"newpath\n";          
	o<<"125 ("<<name<<") stringwidth pop sub ypos moveto\n";
	o<<"("<<name<<") show\n";
	o<<"150 ypos moveto\n";
	o<<"550 ypos lineto\n";
	o<<"150 ypos 10 sub moveto\n";
	o<<"150 ypos 10 add lineto\n";
	o<<"550 ypos 10 sub moveto\n";
	o<<"550 ypos 10 add lineto\n";
	o<<"stroke\n";
	o<<"150 ypos 25 sub moveto ("<<beg<<") show\n";
	o<<"550 ("<<end<<") stringwidth pop sub ypos 25 sub moveto\n";
	o<<"("<<end<<") show\n";
	o<<"closepath\n";
	ps_match_list::iterator l_it = ml.begin();
	ps_match_list::iterator l_end = ml.end();
	for (; l_it != l_end; l_it++)
	{
		int col = get_col(l_it->first);
		int sh = get_sh(l_it->first);
		float pos = get_pos(l_it->second-beg,L);
		o<<"/sh_fill {col"<<col<<"} def\n";
		std::string addsub;
		if (l_it->third)
			addsub = "add";
		else
			addsub = "sub";
		o<<pos<<" ypos 7 "<<addsub<<" sh"<<sh<<"\n";
	}	
}

void print_label(int xpos, int ypos, int j, std::string name, std::ostream& o)
{
	xpos += 15; 
	o<<"/ypos {"<<ypos<<"} def\n";
	o<<"newpath\n";          
	o<<xpos<<" ypos moveto\n";
	o<<"("<<name<<") show\n";
	o<<"closepath\n";
	int col = get_col(j);
	int sh = get_sh(j);
	o<<"/sh_fill {col"<<col<<"} def\n";
	o<<"/ypos {"<<ypos<<"} def\n";
	xpos += 9*name.size();
	o<<xpos<<" ypos sh"<<sh<<"\n";
}

} // end namespace bbq
