// bbq - Copyright (C) 2005, Axel Mosig, University of Leipzig. See
// main.cpp for details.

#include <ostream>
#include "triple.h"
#include <list>
#include <string>

namespace bbq {
	
/// match_list_triple.first = segment or group index j, 0 <= j <= k
/// match_list_triple.second = position within the cluster
/// match_list_triple.third = 3' occurence (true) or 5' occurence
///   (false) - indicates whether to print the symbol above or below the
///   corresponding line.
typedef std::triple<int,int,bool> match_list_triple;

/// a list of matches...
typedef std::list< match_list_triple > ps_match_list;

void print_ps_header(std::ostream& o);

void print_ps_footer(std::ostream& o);

void print_cluster(int ypos, std::string name, int beg, int end, int L, ps_match_list ml, std::ostream& o);

void print_label(int xpos, int ypos, int j, std::string name, std::ostream& o);

int get_col(int j);

int get_sh(int j);
	  
template<class w_bit_set>
void print_cluster_members(int ypos, w_bit_set& C, std::ostream& o)
{
	o<<"newpath\n";          
	o<<"30 "<<ypos<<" moveto\n";
	o<<"(common labels: \173) show\n"; // print "{"
	o<<"closepath\n";
	int j;
	int pos = 155;
	for (j=0; j<w_bit_set::k; j++)
	{
		if (C.contains(j))
		{
			if (pos!=155)
			{
				o<<"newpath\n";          
				o<<pos<<" "<<ypos<<" moveto\n";
				o<<"(\054) show\n"; // print "{"
				o<<"closepath\n";
				pos += 18;
			}
			int col = get_col(j);
			int sh = get_sh(j);
			o<<"/sh_fill {col"<<col<<"} def\n";
			o<<pos<<" "<<ypos+3<<" sh"<<sh<<"\n";
			pos += 12;
		}
	}
	o<<"newpath\n";          
	o<<pos<<" "<<ypos<<" moveto\n";
	o<<"(\175) show\n"; // print "}"
	o<<"closepath\n";
	
}

} // end namespace bbq
