// bbq - Copyright (C) 2005, Axel Mosig, University of Leipzig. See
// main.cpp for details.

#include "clique.h"
#include <iostream>


namespace bbq {
	
int clique::K = 0;

bool clique_member::operator<(const clique_member m) const
{
	if ( i<m.i || (i==m.i && nu < m.nu) )
		return true;
	return false;
}

bool clique_member::operator==(const clique_member m) const
{
	if (i==m.i && nu == m.nu)
		return true;
	return false;
}

clique::clique()
{
}


clique& clique::operator=(const clique& q)
{
	members = new int[K];
	for (int i=0; i<K; i++)
		members[i] = q.members[i];


	color = q.color;

	return *this;
}

clique::clique(const clique& q)
{
	members = new int[K];
	for (int i=0; i<K; i++)
		members[i] = q.members[i];

	color = q.color;	
}

clique::clique(int* q)
{
	members = new int[K];
	for (int i=0; i<K; i++)
		members[i] = q[i];

	color = -1;
	
}

clique::clique(int* q, short int j)
{
	members = new int[K];
	for (int i=0; i<K; i++)
		members[i] = q[i];

	color = j;
	
}

clique::~clique()
{
	delete[] members;
}

	
bool clique::operator==(const clique& q) const
{
	if (color != q.color)
		return false;
	for (int i=0; i<K; i++)
		if (!(q.members[i]==members[i]))
			return false;
	return true;
}

bool clique::operator<(const clique& q) const
{
	if (color < q.color)
		return true;
	else if (color > q.color)
		return true;
	for (int i=0; i<K; i++)
		if (members[i]<q.members[i])
			return true;
		else if (q.members[i]<members[i])
			return false;
	return false;
}
	

clique_features::clique_features(clique* q, int l)
{
	best_path_pred = q;
	best_path_length = l;
}

} // end namespace bbq
